<template>
	<div class="content__leftAnalitika">
		<div class="monitoring-top">
			<div class="monitoring-left wow fadeInLeft">
				<router-link :to="route('promos')" class="link-back">
					<svg>
						<use xlink:href="/img/sprite.svg#long-arrow-pointing-to-the-right"/>
					</svg>
					{{ $t('ui.back') }}
				</router-link>
				<div class="box-img">
					<img src="/img/file11.png" alt="">
				</div>
				<div class="box-text">
					<p class="text-bold">{{ tt('title') }}</p>
					<a href="#" class="link-calculate">{{ tt('subtitle') }}</a>
					<p class="text-grey">{{ tt('three') }}</p>
				</div>
			</div>
			<div class="monitoring-right wow fadeInRight">
				<div class="box-top-icon">
					<p class="title-blue">{{ $t('promos.pages.total_budget') }}</p>
					<svg class="refresh">
						<use xlink:href="/img/sprite.svg#cycle-loading"></use>
					</svg>
				</div>
				<div class="box-right-bottom">
					<div class="box-botton-element">
						<p class="title-grey">{{ tt('budget.first') }}</p>
						<p class="text-bold">$ {{ stats.budget.invested | formatAmount }}</p>
					</div>
					<div class="box-botton-element">
						<p class="title-grey">{{ tt('budget.second') }}</p>
						<p class="text-bold"> $ {{ stats.budget.income | formatAmount }}</p>
					</div>
					<div class="box-botton-element">
						<p class="title-grey">{{ $t('promos.pages.payback') }}</p>
						<p class="text-bold" :class="profitClass">{{ Number.parseFloat(stats.budget.profit_percent).toFixed(2) }}%</p>
					</div>
				</div>
			</div>
		</div>
		<div class="monitoring-search">
			<div class="box-text-left">
				<p class="text-bold wow fadeInLeft">{{ tt('table_title') }}</p>
				<p class="text-monitoring-grey wow fadeInLeft">{{ tt('table_subtitle') }}</p>
			</div>
			<div class="box-right wow fadeInRight">
				<form action="">
					<input type="text" :placeholder="$t('promos.pages.search')" v-model="search" required>
					<button>
						<svg>
							<use xlink:href="/img/sprite.svg#magnifying-glass"></use>
						</svg>
					</button>
				</form>
			</div>
		</div>
		<div class="box-icon-all wow fadeInUp">
			<div class="all-left">
				<div class="all-left-left">
					<svg>
						<use :xlink:href="`/img/sprite.svg#${promoIcon}`"></use>
					</svg>
					{{ tt('total_count') }} {{ stats.total }}
				</div>
				<div class="box-left-right">
					<svg class="cron">
						<use xlink:href="/img/sprite.svg#crown-2"></use>
					</svg>
					<p class="text-head">Самый эффективный блоггер: <span v-if="stats.top">{{ stats.top.name }}</span>
					</p>
				</div>
			</div>
			<div class="all-right">
				<svg class="plus" @click="create_modal_opened = !create_modal_opened">
					<use xlink:href="/img/sprite.svg#plus-sign-in-circle-1"></use>
				</svg>
				<svg class="refresh" @click="reload()">
					<use xlink:href="/img/sprite.svg#cycle-loading"></use>
				</svg>
			</div>
		</div>
		<transition name="modal-slide">
			<create-modal v-show="create_modal_opened" :type="type" @close="create_modal_opened = false"
						  @reload="reload()"/>
		</transition>
		<promos-table :type="type" :search="search" ref="promosTable" @reload="reload()"/>
	</div>
</template>

<script>
import route from "../../mixins/route";
import PromosTable from "./PromosTable";
import CreateModal from "./CreateModal";
import {mapGetters} from "vuex";
import currencies from "../../currencies";

export default {
	name: "PromosPage",
	mixins: [route],
	props: {
		type: {
			required: true,
			type: String
		}
	},
	filters: {
		formatAmount(value){
			return currencies.formatAmount(value);
		}
	},
	data() {
		return {
			create_modal_opened: false,
			search: '',
			stats: {
				total: 0,
				budget: {
					invested: 0,
					income: 0,
					profit_percent: 0,
				}
			}
		}
	},
	computed: {
		...mapGetters([
			'axios'
		]),
		promoIcon() {
			switch (this.type) {
				case 'monitoring':
					return 'pc';
				case 'blog':
					return 'pencil2';
				case 'banner':
					return 'ribbon';
				case 'video':
					return 'youtube00';
			}
		},
		profitClass() {
			return {
				green: this.stats.budget.profit_percent > 0,
				red: this.stats.budget.profit_percent < 0,
			};
		}
	},
	methods: {
		loadStats() {
			this.axios
				.get('promos/stats', {
					params: {
						type: this.type,
					}
				})
				.then(resp => resp.data)
				.then(stats => {
					console.log(stats);
					this.stats = stats;
				});
		},
		tt(key) {
			return this.$t(`promos.pages.${this.type}` + (key ? '.' + key : ''));
		},
		reload() {
			this.$refs.promosTable.submit();
			this.loadStats();
		}
	},
	mounted() {
		this.loadStats()
	},
	components: {
		PromosTable,
		CreateModal
	}
}
</script>

<style scoped lang="scss">
.box-modalPlus {
	max-height: 1000px;
	overflow: hidden;
	left: 50%;
	transform: translate(-50%, 0);
	right: unset;
}

.modal-slide-enter-ative, .modal-slide-leave-active {
	transition: max-height 0.8s ease;
}

.modal-slide-enter, .modal-slide-leave-to {
	max-height: 0px;
}
</style>
